commit:     c87de1ae3f3027a29c7d1db353c5faa17442a21b
Author:     Georgy Yakovlev <gyakovlev <AT> gentoo <DOT> org>
AuthorDate: Fri Sep 27 18:28:37 2019 +0000
Commit:     Georgy Yakovlev <gyakovlev <AT> gentoo <DOT> org>
CommitDate: Fri Sep 27 19:16:19 2019 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=c87de1ae

sys-fs/zfs: bump to 0.8.2

Package-Manager: Portage-2.3.76, Repoman-2.3.17
RepoMan-Options: --ignore-arches
Signed-off-by: Georgy Yakovlev <gyakovlev <AT> gentoo.org>

 sys-fs/zfs/Manifest                                |   1 +
 .../files/0.8.2-ZPOOL_IMPORT_UDEV_TIMEOUT_MS.patch |  68 +++++++
 sys-fs/zfs/zfs-0.8.2.ebuild                        | 223 +++++++++++++++++++++
 3 files changed, 292 insertions(+)

diff --git a/sys-fs/zfs/Manifest b/sys-fs/zfs/Manifest
index daccededfad..1c908ae93b7 100644
--- a/sys-fs/zfs/Manifest
+++ b/sys-fs/zfs/Manifest
@@ -1,2 +1,3 @@
 DIST zfs-0.7.13.tar.gz 6614047 BLAKE2B 
c59c46287715779eb04d69333b0a417fa9865eb0d61c642b043188c4c97d4eed369f76a48327326ed1d4dd608ff95d91d20d26c80ed0b120a8fcd5f83cea638f
 SHA512 
457d8f110b68c9656194cd3738b216d5d807d680e5cfc6ed1f3cf5ebde67860476387c6b862ba3ba7f972d8945075963e6c325543ab84468e3eff5dbce68476e
 DIST zfs-0.8.1.tar.gz 8668360 BLAKE2B 
f18268656381c20af6bd18421636a1c56633c7eafaf91b1308d15508d5f4bdcfa5dfbb4e09d0302ac3de9d6a4f69718fe9c3d083ed5b3ab2a32c6fb7a1db624b
 SHA512 
1fb3957f65dbe94edaffcedb5b2694390dc14e472c11f7e63184a9ea6a774e79a43d47a2d789b7ced233fc67c76583bf7d5c1bda0692bb07929673e2a57f4667
+DIST zfs-0.8.2.tar.gz 8738111 BLAKE2B 
5c15f6664ca70f0deeb5b9e32f2bcff68f9821529e5203ff18612ce88473fee9af369354c442f3db7882d301cf17c805c9635b05bfd3460833ed8e5ff8004dd0
 SHA512 
1424b1a030b814f812b5da422100669db5b8c3ccae14c2fdd62a5e0df28e7255247fe5ca99c95a14f08c92cc1574c22dd132093e4a1dd81e38c95b10cc5e2496

diff --git a/sys-fs/zfs/files/0.8.2-ZPOOL_IMPORT_UDEV_TIMEOUT_MS.patch 
b/sys-fs/zfs/files/0.8.2-ZPOOL_IMPORT_UDEV_TIMEOUT_MS.patch
new file mode 100644
index 00000000000..6c4054ddb66
--- /dev/null
+++ b/sys-fs/zfs/files/0.8.2-ZPOOL_IMPORT_UDEV_TIMEOUT_MS.patch
@@ -0,0 +1,68 @@
+From d7037d2a2fd57504070eba14634b8a7ea159de32 Mon Sep 17 00:00:00 2001
+From: Richard Yao <r...@gentoo.org>
+Date: Thu, 1 Aug 2019 15:54:30 -0400
+Subject: [PATCH] Implement ZPOOL_IMPORT_UDEV_TIMEOUT_MS
+
+Since 0.7.0, zpool import would unconditionally block on udev for 30
+seconds. This introduced a regression in initramfs environments that
+lack udev (particularly mdev based environments), yet use a zfs userland
+tools intended for the system that had been built against udev. Gentoo's
+genkernel is the main example, although custom user initramfs
+environments would be similarly impacted unless special builds of the
+ZFS userland utilities were done for them.  Such environments already
+have their own mechanisms for blocking until device nodes are ready
+(such as genkernel's scandelay parameter), so it is unnecessary for
+zpool import to block on a non-existent udev until a timeout is reached
+inside of them.
+
+Rather than trying to intelligently determine whether udev is avaliable
+on the system to avoid unnecessarily blocking in such environments, it
+seems best to just allow the environment to override the timeout.  I
+propose that we add an environment variable called
+ZPOOL_IMPORT_UDEV_TIMEOUT_MS. Setting it to 0 would restore the 0.6.x
+behavior that was more desireable in mdev based initramfs environments.
+This allows the system userland utilities to be reused when building
+mdev-based initramfs archives.
+
+Reviewed-by: Georgy Yakovlev <gyakov...@gentoo.org>
+Signed-off-by: Richard Yao <r...@gentoo.org>
+---
+ lib/libzutil/zutil_import.c | 10 +++++++++-
+ 1 file changed, 9 insertions(+), 1 deletion(-)
+
+diff --git a/lib/libzutil/zutil_import.c b/lib/libzutil/zutil_import.c
+index e82744383dc..8c4d8c5cb5c 100644
+--- a/lib/libzutil/zutil_import.c
++++ b/lib/libzutil/zutil_import.c
+@@ -58,6 +58,7 @@
+ #endif
+ #include <stddef.h>
+ #include <stdlib.h>
++#include <stdio.h>
+ #include <string.h>
+ #include <sys/stat.h>
+ #include <unistd.h>
+@@ -1653,15 +1654,22 @@ zpool_open_func(void *arg)
+               char *devid = NULL;
+               rdsk_node_t *slice;
+               avl_index_t where;
++              char *env;
++              int timeout;
+               int error;
+ 
+               if (label_paths(rn->rn_hdl, rn->rn_config, &path, &devid))
+                       return;
+ 
++              env = getenv("ZPOOL_IMPORT_UDEV_TIMEOUT_MS");
++
++              if ((env == NULL) || sscanf(env, "%d", &timeout) != 1)
++                      timeout = DISK_LABEL_WAIT;
++
+               /*
+                * Allow devlinks to stabilize so all paths are available.
+                */
+-              zpool_label_disk_wait(rn->rn_name, DISK_LABEL_WAIT);
++              zpool_label_disk_wait(rn->rn_name, timeout);
+ 
+               if (path != NULL) {
+                       slice = zfs_alloc(hdl, sizeof (rdsk_node_t));

diff --git a/sys-fs/zfs/zfs-0.8.2.ebuild b/sys-fs/zfs/zfs-0.8.2.ebuild
new file mode 100644
index 00000000000..dd0ca35654d
--- /dev/null
+++ b/sys-fs/zfs/zfs-0.8.2.ebuild
@@ -0,0 +1,223 @@
+# Copyright 1999-2019 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+DISTUTILS_OPTIONAL=1
+PYTHON_COMPAT=( python{2_7,3_{5,6,7}} )
+
+inherit bash-completion-r1 flag-o-matic linux-info linux-mod distutils-r1 
systemd toolchain-funcs udev usr-ldscript
+
+DESCRIPTION="Userland utilities for ZFS Linux kernel module"
+HOMEPAGE="https://zfsonlinux.org/";
+
+if [[ ${PV} == "9999" ]] ; then
+       inherit autotools git-r3
+       EGIT_REPO_URI="https://github.com/zfsonlinux/zfs.git";
+else
+       
SRC_URI="https://github.com/zfsonlinux/${PN}/releases/download/${P}/${P}.tar.gz";
+       KEYWORDS="~amd64 ~arm64 ~ppc64"
+fi
+
+LICENSE="BSD-2 CDDL MIT"
+SLOT="0"
+IUSE="custom-cflags debug kernel-builtin libressl python +rootfs test-suite 
static-libs"
+
+DEPEND="
+       ${PYTHON_DEPS}
+       net-libs/libtirpc[static-libs?]
+       sys-apps/util-linux[static-libs?]
+       sys-libs/zlib[static-libs(+)?]
+       virtual/awk
+       virtual/libudev[static-libs?]
+       libressl? ( dev-libs/libressl:0=[static-libs?] )
+       !libressl? ( dev-libs/openssl:0=[static-libs?] )
+       python? (
+               virtual/python-cffi[${PYTHON_USEDEP}]
+       )
+"
+
+BDEPEND="virtual/awk
+       virtual/pkgconfig
+       python? (
+               dev-python/setuptools[${PYTHON_USEDEP}]
+       )
+"
+
+RDEPEND="${DEPEND}
+       !=sys-apps/grep-2.13*
+       !kernel-builtin? ( ~sys-fs/zfs-kmod-${PV} )
+       !sys-fs/zfs-fuse
+       !prefix? ( virtual/udev )
+       sys-fs/udev-init-scripts
+       rootfs? (
+               app-arch/cpio
+               app-misc/pax-utils
+               !<sys-boot/grub-2.00-r2:2
+               !<sys-kernel/genkernel-3.5.1.1
+               !<sys-kernel/genkernel-next-67
+               !<sys-kernel/bliss-initramfs-7.1.0
+               !<sys-kernel/dracut-044-r1
+       )
+       test-suite? (
+               sys-apps/util-linux
+               sys-devel/bc
+               sys-block/parted
+               sys-fs/lsscsi
+               sys-fs/mdadm
+               sys-process/procps
+               virtual/modutils
+       )
+"
+
+REQUIRED_USE="${PYTHON_REQUIRED_USE}"
+
+RESTRICT="test"
+
+PATCHES=(
+       "${FILESDIR}/bash-completion-sudo.patch"
+       "${FILESDIR}/0.8.2-ZPOOL_IMPORT_UDEV_TIMEOUT_MS.patch" # 
https://github.com/zfsonlinux/zfs/pull/9109
+)
+
+pkg_setup() {
+       if use kernel_linux && use test-suite; then
+               linux-info_pkg_setup
+
+               if  ! linux_config_exists; then
+                       ewarn "Cannot check the linux kernel configuration."
+               else
+                       if use test-suite; then
+                               if linux_chkconfig_present BLK_DEV_LOOP; then
+                                       eerror "The ZFS test suite requires 
loop device support enabled."
+                                       eerror "Please enable it:"
+                                       eerror "    CONFIG_BLK_DEV_LOOP=y"
+                                       eerror "in /usr/src/linux/.config or"
+                                       eerror "    Device Drivers --->"
+                                       eerror "        Block devices --->"
+                                       eerror "            [X] Loopback device 
support"
+                               fi
+                       fi
+               fi
+       fi
+}
+
+src_prepare() {
+       default
+
+       if [[ ${PV} == "9999" ]]; then
+               eautoreconf
+       else
+               # Set revision number
+               sed -i "s/\(Release:\)\(.*\)1/\1\2${PR}-gentoo/" META || die 
"Could not set Gentoo release"
+       fi
+
+       if use python; then
+               pushd contrib/pyzfs >/dev/null || die
+               distutils-r1_src_prepare
+               popd >/dev/null || die
+       fi
+
+       # prevent errors showing up on zfs-mount stop, #647688
+       # openrc will unmount all filesystems anyway.
+       sed -i "/^ZFS_UNMOUNT=/ s/yes/no/" etc/init.d/zfs.in || die
+}
+
+src_configure() {
+       use custom-cflags || strip-flags
+
+       local myconf=(
+               --bindir="${EPREFIX}/bin"
+               --enable-shared
+               --enable-systemd
+               --enable-sysvinit
+               --localstatedir="${EPREFIX}/var"
+               --sbindir="${EPREFIX}/sbin"
+               --with-config=user
+               --with-dracutdir="${EPREFIX}/usr/lib/dracut"
+               --with-linux="${KV_DIR}"
+               --with-linux-obj="${KV_OUT_DIR}"
+               --with-udevdir="$(get_udevdir)"
+               --with-systemdunitdir="$(systemd_get_systemunitdir)"
+               --with-systemdpresetdir="${EPREFIX}/lib/systemd/system-preset"
+               $(use_enable debug)
+               $(use_enable python pyzfs)
+               $(use_enable static-libs static)
+       )
+
+       econf "${myconf[@]}"
+}
+
+src_compile() {
+       default
+       if use python; then
+               pushd contrib/pyzfs >/dev/null || die
+               distutils-r1_src_compile
+               popd >/dev/null || die
+       fi
+}
+
+src_install() {
+       default
+
+       gen_usr_ldscript -a uutil nvpair zpool zfs zfs_core
+
+       use test-suite || rm -rf "${ED}/usr/share/zfs"
+
+       if ! use static-libs; then
+               find "${ED}/" -name '*.la' -delete || die
+       fi
+
+       dobashcomp contrib/bash_completion.d/zfs
+       bashcomp_alias zfs zpool
+
+       # strip executable bit from conf.d file
+       fperms 0644 /etc/conf.d/zfs
+
+       if use python; then
+               pushd contrib/pyzfs >/dev/null || die
+               distutils-r1_src_install
+               popd >/dev/null || die
+       fi
+
+       # enforce best available python implementation
+       python_setup
+       python_fix_shebang "${ED}/bin"
+}
+
+pkg_postinst() {
+       if use rootfs; then
+               if ! has_version sys-kernel/genkernel && ! has_version 
sys-kernel/dracut; then
+                       elog "root on zfs requires initramfs to boot"
+                       elog "the following packages known to provide one and 
tested on regular basis:"
+                       elog "  sys-kernel/dracut"
+                       elog "  sys-kernel/genkernel"
+               fi
+
+               if has_version "<=sys-kernel/genkernel-3.5.3.3"; then
+                       einfo "genkernel version 3.5.3.3 and earlier does NOT 
support"
+                       einfo " unlocking pools with native zfs encryption 
enabled at boot"
+                       einfo " use dracut or >=genkernel-4 if you requre this 
functionality"
+               fi
+       fi
+
+       if ! use kernel-builtin && [[ ${PV} = "9999" ]]; then
+               einfo "Adding ${P} to the module database to ensure that the"
+               einfo "kernel modules and userland utilities stay in sync."
+               update_moduledb
+       fi
+
+       [[ -e "${EROOT}/etc/runlevels/boot/zfs-import" ]] || \
+               einfo "You should add zfs-import to the boot runlevel."
+       [[ -e "${EROOT}/etc/runlevels/boot/zfs-mount" ]]|| \
+               einfo "You should add zfs-mount to the boot runlevel."
+       [[ -e "${EROOT}/etc/runlevels/default/zfs-share" ]] || \
+               einfo "You should add zfs-share to the default runlevel."
+       [[ -e "${EROOT}/etc/runlevels/default/zfs-zed" ]] || \
+               einfo "You should add zfs-zed to the default runlevel."
+}
+
+pkg_postrm() {
+       if ! use kernel-builtin && [[ ${PV} == "9999" ]]; then
+               remove_moduledb
+       fi
+}

Reply via email to